#include <errno.h>
#include <fcntl.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <sys/mman.h>
#include <sys/stat.h>
#include "fuseactions.h"

unsigned char* tempfs;

// Map filesystem to memory
void MapFS(int fd)
{
    tempfs = mmap(NULL, FSSIZE, PROT_READ | PROT_WRITE, MAP_SHARED, fd, 0);
    if (tempfs == NULL)
    {
        perror("mmap failed");
        exit(EXIT_FAILURE);
    }
    close(fd);
    return;
}

// Unmap filesystem from memory
void UnmapFS(void)
{
    munmap(tempfs, FSSIZE);
    return;
}

// Sets defaults of a new filesystem
void FormatFS(FileSystem* fs)
{
    SetFileSystemDefaults(fs);
    SetupRootDirectory(fs);
    return;
}

// Redirect global pointer to structured local pointer
void LoadFS(FileSystem** fs)
{
    *fs = (FileSystem*) (tempfs);
    return;
}

// List path names of all used inodes
// TODO: Fix implementation to print starting at Inode 0
void ListFS(FileSystem* fs)
{
    Inode* fsRoot = &(fs->inodes[0]);
    printf("/\n");
    for (int i = 0; i < fs->superBlock.inodeCount; i++)
    {
        if (!(fsRoot->inodeBlocks[i].isValid))
            continue;
        printf("%s\n", fsRoot->inodeBlocks[i].name);
    }
    return;
}

// Depreciated due to new structure method
void _RecursivePrintFS_(FileSystem* fs, ino_t inodePosition)
{
    // for (int i = 0; i < DEFAULTINODEMAX; i++)
    // {
    //     if (!(fs->inodes[inodePosition].inodeBlocks[i].info.isValid))
    //         continue;
    //     printf("%s\n", fs->inodes[inodePosition].inodeBlocks[i].info.filePath);
    //     if (fs->inodes[inodePosition].inodeBlocks[i].info.isDirectory)
    //         _RecursivePrintFS_(fs, fs->inodes[inodePosition].inodeBlocks[i].info.inode);
    // }
    return;
}

int FindNextDirectory(char* fname)
{
    int i = 0;
    while (fname[i] != '\0')
    {
        if (fname[i] == '/')
            return i;
        i++;
    }
    return -1;
}

// Adds a file to the filesystem
// TODO: Fix implementation to add starting at Inode 0
void AddFileToFS(FileSystem* fs, char* fname)
{
    struct stat statBuffer;
    ino_t inodeNumber = GetFreeInodeNumber(fs->fbl.freeList);
    // strcpy(fs->inodes[inodeNumber].info.filePath, fname);
    // stat(fname, &statBuffer);
    // fs->inodes[inodeNumber].info.fileSize = statBuffer.st_size;
    // int fd = open(fname, O_RDONLY);
    // if (fd < 0)
    // {
    //     perror(fname);
    //     exit(1);
    // }
    // read(fd, fs->inodes[inodeNumber].dataBlocks.byte, sizeof(BlockStruct));
    // close(fd);
    return;
}

// Depreciated due to new structure method
void _RecursiveAddFS_(FileSystem* fs, char* fname)
{
    return;
}

// Remove a file from the filesystem
// TODO: Fix function so that it adds directories, then the file after
void RemoveFileFromFS(FileSystem* fs, char* fname)
{

}

// Extract a file from the filesystem
// TODO: Fix function so that it adds directories, then the file after
void ExtractFileFromFS(FileSystem* fs, char* fname)
{
    
}
